#ifndef BUILDDEFS_H
#define BUILDDEFS_H

#include "byteorder.h"

/* ----------- compile options (user definable) ------------- */

/* the virtual directory where our development (test) datafiles are after init*/
#define DEV_DATA_PATH	"/devdata"

/* define this to disable support for the XBox360 gamepad on a PC */
#undef DISABLE_XBOX_PAD

/* define this to generate D3D debug info, doesn't affect OpenGL version */
#undef D3D_DEBUG_INFO

/* define this to use OpenGL instead of D3D on windows (no effect on UNIX obviously) */
#undef BUILD_GL


/* ------- non-options section, don't change lightly -------- */

#if !defined(WIN32) && !defined(__WIN32__)
#ifdef _MSC_VER
#define WIN32
#endif
#endif	/* !def win32 */

#if defined(WIN32) || defined(__WIN32__)
#define BUILD_WIN32

/* default to D3D on windows, unless defined otherwise above */
#ifndef BUILD_GL
#define BUILD_DX9
#endif

#define WSYS_WIN32
#endif

#if defined(unix) || defined(__unix__)
#define BUILD_UNIX

/* only OpenGL on UNIX of course */
#ifndef BUILD_GL
#define BUILD_GL
#endif

#define WSYS_X11
#endif

/* if we're building for xbox or we're on windows and DISABLE_XBOX_PAD isn't defined... enable it */
#if defined(BUILD_XBOX) || ((defined(WIN32) || defined(__WIN32__)) && !defined(DISABLE_XBOX_PAD))
#define USE_XBOX_PAD
#endif

/* disable stupid MSVC warnings */
#ifdef _MSC_VER
#pragma warning(disable: 4800)	/* int->bool performance warning */
#pragma warning(disable: 4305)	/* truncation double->float */
/*#pragma warning(disable: 4018)*/	/* comparison signed/unsigned mismatch */
/*#pragma warning(disable: 4267)*/	/* conversion from something to something, possible loss of data */
#endif

#endif /* BUILDDEFS_H */
