#ifndef BYTEORDER_H
#define BYTEORDER_H

/* This seems to work, I don't want to see the contents of this file again ... ever */

#if !defined(BYTE_ORDER) && !defined(__BYTE_ORDER)
#	if !defined(LITTLE_ENDIAN) && !defined(BIG_ENDIAN)
#		if  defined(__i386__) || defined(__ia64__) || \
			defined(WIN32) || defined(__WIN32__) || \
    		(defined(__alpha__) || defined(__alpha)) || \
		     defined(__arm__) || \
		    (defined(__mips__) && defined(__MIPSEL__)) || \
		     defined(__SYMBIAN32__) || \
		     defined(__x86_64__) || \
		     defined(__LITTLE_ENDIAN__)

#			define T7ENG_DETECTED_LENDIAN
#		else
#			define T7ENG_DETECTED_BENDIAN
#		endif
#	endif
#else
#	if (defined(BYTE_ORDER) && BYTE_ORDER == LITTLE_ENDIAN) || (defined(__BYTE_ORDER) && __BYTE_ORDER == __LITTLE_ENDIAN)
#		define T7ENG_DETECTED_LENDIAN
#	else
#		define T7ENG_DETECTED_BENDIAN
#	endif
#endif

#ifdef T7ENG_DETECTED_LENDIAN
#	ifndef LITTLE_ENDIAN
#		define LITTLE_ENDIAN
#	endif
#	ifdef BIG_ENDIAN
#		undef BIG_ENDIAN
#	endif
#elif defined(T7ENG_DETECTED_BENDIAN)
#	ifndef BIG_ENDIAN
#		define BIG_ENDIAN
#	endif
#	ifdef LITTLE_ENDIAN
#		undef LITTLE_ENDIAN
#	endif
#else
#	error "something went very wrong with the endianess detection shit..."
#endif


/* also define the color shift ammounts */

/* these two tend to remain the same in both byteorders by convention (?) */
#define ASHIFT		24
#define GSHIFT		8

#ifdef LITTLE_ENDIAN
#define RSHIFT		16
#define BSHIFT		0
#else	/* BIG ENDIAN */
#define RSHIFT		0
#define BSHIFT		16
#endif	/* endianess */

#endif	/* BYTEORDER_H */
