// anm.h

#ifndef _ANM_HEADER_
#define _ANM_HEADER_

#include "chunkff.h"
#include "chunk_types.h"
#include <prs.h>


enum AnimationChunk
{
	ANM_MAIN = 0x304D4E41, // ascii "ANM0" (little endian)
	ANM_KEYFRAME_CHUNK
}; // end enum AnimationChunk

class KeyframeChunk : public Chunk
{
private:
	struct KeyframeData
	{
		unsigned int node_id;
		unsigned int keyframe_count;
		PRS default_local_prs;
	};
protected:

public:
	KeyframeChunk();
	~KeyframeChunk();

	unsigned int GetID() const
	{
		return ANM_KEYFRAME_CHUNK;
	}

	unsigned long GetNodeID() const;
	void SetNodeID(unsigned long node_id);

	unsigned long GetKeyframeCount() const;
	void SetKeyframeCount(unsigned long count);

	PRS* GetKeyframes();

	PRS GetDefaultPRS() const;
	void SetDefaultPRS(const PRS &default_prs);

}; // end class KeyframeChunk

//TODO : na broume mia lish gia check an to anm einai sto swsto sce

class AnimationFile : public NamedChunk
{
private:
	struct AnimationHeader
	{
		unsigned int version;
		unsigned int fps;
	};
public:
	AnimationFile();
	~AnimationFile();

	unsigned int GetID() const
	{
		return ANM_MAIN;
	}

	unsigned long GetVersion() const;
	void SetVersion(unsigned long version);

	std::string GetMessage() const;
	void SetMessage(const std::string& message);

	unsigned long GetFPS() const;
	void SetFPS(unsigned long fps);

	// high level
	unsigned long GetKeyframeChunkCount() const;
	KeyframeChunk* GetKeyframeChunk(unsigned long id) const;

}; // end class AnimationFile

#endif // ndef _ANM_HEADER_
