// NOTE: an issue is whether or not we want to add/subtract the alpha component along with the rest.

#include "math3d/math3d.h"

inline Color operator +(const Color &c1, const Color &c2)
{
	return Color(c1.r + c2.r, c1.g + c2.g, c1.b + c2.b, c1.a);
}

inline Color operator -(const Color &c1, const Color &c2)
{
	return Color(c1.r - c2.r, c1.g - c2.g, c1.b - c2.b, c1.a);
}

inline Color operator *(const Color &c1, const Color &c2)
{
	return Color(c1.r * c2.r, c1.g * c2.g, c1.b * c2.b, c1.a);
}

inline Color operator /(const Color &c1, const Color &c2)
{
	return Color(c1.r / c2.r, c1.g / c2.g, c1.b / c2.b, c1.a);
}

inline void operator +=(Color &c1, const Color &c2)
{
	c1.r += c2.r;
	c1.g += c2.g;
	c1.b += c2.b;
}

inline void operator -=(Color &c1, const Color &c2)
{
	c1.r -= c2.r;
	c1.g -= c2.g;
	c1.b -= c2.b;
}

inline void operator *=(Color &c1, const Color &c2)
{
	c1.r *= c2.r;
	c1.g *= c2.g;
	c1.b *= c2.b;
}

inline void operator /=(Color &c1, const Color &c2)
{
	c1.r /= c2.r;
	c1.g /= c2.g;
	c1.b /= c2.b;
}

inline unsigned int PackColor(const Color &c)
{
    float r = CLAMP(c.r, 0, 1.0f);
    float g = CLAMP(c.g, 0, 1.0f);
    float b = CLAMP(c.b, 0, 1.0f);
    float a = CLAMP(c.a, 0, 1.0f);

	return PACKF_RGBA(r, g, b, a);
}

inline Color UnpackColor(unsigned int p)
{
	Color c;
	c.r = UNPACKF_RED(p);
	c.g = UNPACKF_GREEN(p);
	c.b = UNPACKF_BLUE(p);
	c.a = UNPACKF_ALPHA(p);
	return c;
}
