#include <builddefs.h>
#include <libvfs.h>
#include <errlog.h>
#include "devhelp.h"

static const char *edata_paths[] = {
	"engine_data",
	"../engine_data",
	"../../engine_data",
	"../../../engine_data",
#if defined(WIN32) || defined(__WIN32__)
	"c:/engine/engine_data",
	"c:/code/theseis/engine/engine_data",
#endif	/* win32 */
#if defined(unix) || defined(__unix__)
	"/usr/local/share/theseis/engine_data",
	"/usr/share/theseis/engine_data",
	"/home/nuclear/code/track7/engine/engine_data",
#endif	/* unix */
	0
};

bool MountDevData()
{
	static bool mounted;

	if(mounted) return true;

	vfs_mkdir(DEV_DATA_PATH, 0666);

	const char **edpath = edata_paths;
	while(*edpath) {
		Info("searching for engine_data ...\n");
		Info("trying: %s ...", *edpath);
		if(vfs_mount(*edpath, DEV_DATA_PATH) == -1) {
			Info("not found\n");
		} else {
			Info("found\n");
			mounted = true;
			return true;
		}
		edpath++;
	}
	return false;
}
