#ifndef ERRLOG_H_
#define ERRLOG_H_

#include <stdio.h>

#ifdef __cplusplus
extern "C" {
#endif	/* __cplusplus */

enum {
	LOG_INFO		= 1,	/* 001 */
	LOG_WARNING		= 2,	/* 010 */
	LOG_ERROR		= 4,	/* 100 */

	LOG_ALL			= 7		/* 111 */
};

void SetLogFile(const char *fname, unsigned int mtypes);
void SetLogStream(FILE *fp, unsigned int mtypes);
void SetLogCallback(void (*func)(const char*), unsigned int mtypes);

void Info(const char *str, ...);
void Warning(const char *str, ...);
void Error(const char *str, ...);

#ifdef __cplusplus
}
#endif	/* __cplusplus */

#endif	/* ERRLOG_H_ */
