/* type.h finds the appropriate way to define sized integer types
 * and also defines the standard scalar type based on the configuration.
 */
#ifndef FOO_TYPES_H_
#define FOO_TYPES_H_

#include <stdlib.h>		/* to get __GLIBC__ defined if applicable */

#if defined(__MACH__) || defined(__MINGW32__)
#define HAVE_STDINT_H
#endif	/* explicitly set stdint.h availability for some platform */

#if (__STDC_VERSION__ >= 199900) || defined(__GLIBC__) || defined(HAVE_STDINT_H)
#include <stdint.h>
#elif defined(unix) || defined(__unix__)
#include <sys/types.h>
#elif defined(_MSC_VER) || defined (BORLAND)
typedef __int8 int8_t;
typedef unsigned __int8 uint8_t;
typedef __int16 int16_t;
typedef unsigned __int16 uint16_t;
typedef __int32 int32_t;
typedef unsigned __int32 uint32_t;
typedef __int64 int64_t;
typedef unsigned __int64 uint64_t;
#else
#error "unsupported platform, or detection failed"
#endif	/* stdint detection */

#endif	/* FOO_TYPES_H_ */
