#ifndef _GOBJECT_H_
#define _GOBJECT_H_

#include <string>
#include <map>
#include <objectgroup.h>

class GameObjGroup {
protected:
	std::string name;
	ObjectGroup *obj;
	std::map<std::string, std::string> anim_names;

public:
	GameObjGroup();
	virtual ~GameObjGroup();

	virtual void SetName(const char *name);
	virtual const char *GetName() const;

    virtual bool Load(const char *fname);
	virtual bool LoadAnimation(const char *fname, const char *name = 0);
};
/*
class Character : public GameObjGroup {
private:
	OGNode *parent;

public:
	Character();
	virtual ~Character();

	virtual void SetParent(OGNode *p);
	virtual OGNode *GetParent() const;
};
*/

#endif	// _GOBJECT_H_
