#ifndef LEVEL_H_
#define LEVEL_H_

#include <map>
#include <string>
#include <math3d.h>
#include <objectgroup.h>
#include <scene.h>
#include "gobject.h"

class Level {
private:
	std::map<std::string, GameObjGroup*> objmap;
	Scene *scene;
	unsigned int time_step;

	TargetCamera *player_cam;

public:
	Level();
	~Level();

	bool Load(const char *fname, void (*progr_func)(float) = 0);

	// pass input events
	void KeyEvent(int key, bool state);
	void MotionEvent(int x, int y, unsigned int bnmask);
	void ButtonEvent(int x, int y, int bn, bool state);

	void SetTimeStep(unsigned int msec);
	unsigned int GetTimeStep() const;

	void Update();
};

#endif	// LEVEL_H_
