#include <builddefs.h>

#ifdef BUILD_DX9

#include "caps.h"
#include <d3d9.h>
#include <errlog.h>

static GcCaps caps;
static bool valid = false;
D3DCAPS9 d3d_caps;

extern IDirect3DDevice9 *d3d_device;

static bool Init()
{
	if (!d3d_device)
	{
		Error("caps.cpp : call to init without initializing d3d_device\n");
		return false;
	}

	if (FAILED( d3d_device->GetDeviceCaps(&d3d_caps) )) return false;

	caps.max_tex_w = d3d_caps.MaxTextureWidth;
	caps.max_tex_h = d3d_caps.MaxTextureHeight;
	caps.max_aspect_ratio = d3d_caps.MaxTextureAspectRatio;

	if (!(d3d_caps.TextureCaps & D3DPTEXTURECAPS_POW2) && 
		!(d3d_caps.TextureCaps & D3DPTEXTURECAPS_NONPOW2CONDITIONAL))
	{
		caps.npot_textures = true;
	}
	else
	{
		caps.npot_textures = false;
	}

	return true;
}

GcCaps *GetGcCaps()
{
	if (!valid)
	{
		if (Init()) valid = true;
	}
	if (!valid) return 0;
	return &caps;
}

unsigned int GetTexMemory()
{
	if (!d3d_device) return 0;
	return d3d_device->GetAvailableTextureMem();
}

#endif	/* BUILD_DX9 */
