#include <builddefs.h>

#ifdef BUILD_GL

#include <string.h>
#include <sysgc.h>
#include "caps.h"

static GcCaps caps;
static bool valid = false;

static bool Init()
{
	const char *ext_str = (const char*)glGetString(GL_EXTENSIONS);

	glGetIntegerv(GL_MAX_TEXTURE_SIZE, &caps.max_tex_w);
	caps.max_tex_h = caps.max_tex_w;
	caps.max_aspect_ratio = 2048;	/* (safe value? check out if GL can provide this capability) */

	caps.npot_textures = (strstr(ext_str, "GL_ARB_texture_non_power_of_two") != 0);
	return true;
}

GcCaps *GetGcCaps()
{
	if(!valid && !(valid = Init())) {
		return 0;
	}
	return &caps;
}

unsigned int GetTexMemory()
{
	return UNLIMITED_VRAM;
}

#endif	/* BUILD_GL */
