#ifndef RESMAN_H
#define RESMAN_H

#include <vector>

class IdMan
{
protected:
	unsigned int uid;
	std::vector<void*> resources;
	std::vector<unsigned int> uids;
	void (*destructor) (void*);
public:
	IdMan (void (*destructor) (void*));
	virtual ~IdMan ();

	virtual unsigned int Add(void *resource, unsigned int id = 0);
	virtual void Remove (unsigned int id);
	void *Get (unsigned int id) const;
	bool IsHandle (unsigned int id) const;
	unsigned int GetUID (unsigned int id) const;
	unsigned int GetResCount () const;

	virtual void Clear ();
};


class IdManRef : public IdMan
{
protected:
	std::vector<unsigned int> refs;
public:
	IdManRef (void (*destructor) (void*));
	virtual ~IdManRef ();

	virtual unsigned int Add (void *resource, unsigned int id = 0);
	virtual void Remove (unsigned int id);
	virtual void Clear ();

	void AddRef (unsigned int id);
};



#endif //RESMAN_H
