#include "statecache.h"
#include "uniforms.h"



unsigned int STATE_MODEL_MATRIX = 0;
unsigned int STATE_VIEW_MATRIX = 0;
unsigned int STATE_PROJECTION_MATRIX = 0;
unsigned int STATE_MODELVIEW_MATRIX = 0;
unsigned int STATE_MODELVIEWPROJECTION_MATRIX = 0;
unsigned int STATE_MODELVIEW_INVERSE_MATRIX = 0;
unsigned int STATE_AUX_MATRIX = 0;

unsigned int STATE_TEXTURE0_MATRIX = 0;
unsigned int STATE_TEXTURE1_MATRIX = 0;
unsigned int STATE_TEXTURE2_MATRIX = 0;
unsigned int STATE_TEXTURE3_MATRIX = 0;
unsigned int STATE_TEXTURE4_MATRIX = 0;
unsigned int STATE_TEXTURE5_MATRIX = 0;
unsigned int STATE_TEXTURE6_MATRIX = 0;
unsigned int STATE_TEXTURE7_MATRIX = 0;

unsigned int STATE_TEXTURE_PROJECTION_MATRIX = 0;
unsigned int STATE_PROJECTOR_MVP = 0;
unsigned int STATE_PROJECTOR_POS = 0;
unsigned int STATE_LIGHTMAP_POWER = 0;

unsigned int STATE_BONE_MATRIX = 0;

unsigned int STATE_LIGHT0_POS = 0;
unsigned int STATE_LIGHT0_WPOS = 0;
unsigned int STATE_LIGHT0_DIR = 0;
unsigned int STATE_LIGHT0_AMBIENT = 0;
unsigned int STATE_LIGHT0_DIFFUSE = 0;
unsigned int STATE_LIGHT0_SPECULAR = 0;
unsigned int STATE_LIGHT0_INNER = 0;
unsigned int STATE_LIGHT0_OUTER = 0;
unsigned int STATE_LIGHT0_ATTEN_START = 0;
unsigned int STATE_LIGHT0_ATTEN_END = 0;

unsigned int STATE_LIGHT1_POS = 0;
unsigned int STATE_LIGHT1_WPOS = 0;
unsigned int STATE_LIGHT1_DIR = 0;
unsigned int STATE_LIGHT1_AMBIENT = 0;
unsigned int STATE_LIGHT1_DIFFUSE = 0;
unsigned int STATE_LIGHT1_SPECULAR = 0;
unsigned int STATE_LIGHT1_INNER = 0;
unsigned int STATE_LIGHT1_OUTER = 0;
unsigned int STATE_LIGHT1_ATTEN_START = 0;
unsigned int STATE_LIGHT1_ATTEN_END = 0;

unsigned int STATE_LIGHT2_POS = 0;
unsigned int STATE_LIGHT2_WPOS = 0;
unsigned int STATE_LIGHT2_DIR = 0;
unsigned int STATE_LIGHT2_AMBIENT = 0;
unsigned int STATE_LIGHT2_DIFFUSE = 0;
unsigned int STATE_LIGHT2_SPECULAR = 0;
unsigned int STATE_LIGHT2_INNER = 0;
unsigned int STATE_LIGHT2_OUTER = 0;
unsigned int STATE_LIGHT2_ATTEN_START = 0;
unsigned int STATE_LIGHT2_ATTEN_END = 0;

unsigned int STATE_LIGHT3_POS = 0;
unsigned int STATE_LIGHT3_WPOS = 0;
unsigned int STATE_LIGHT3_DIR = 0;
unsigned int STATE_LIGHT3_AMBIENT = 0;
unsigned int STATE_LIGHT3_DIFFUSE = 0;
unsigned int STATE_LIGHT3_SPECULAR = 0;
unsigned int STATE_LIGHT3_INNER = 0;
unsigned int STATE_LIGHT3_OUTER = 0;
unsigned int STATE_LIGHT3_ATTEN_START = 0;
unsigned int STATE_LIGHT3_ATTEN_END = 0;

unsigned int STATE_MATERIAL_AMBIENT = 0;
unsigned int STATE_MATERIAL_DIFFUSE = 0;
unsigned int STATE_MATERIAL_SPECULAR = 0;
unsigned int STATE_MATERIAL_EMISSIVE = 0;
unsigned int STATE_MATERIAL_POWER = 0;

unsigned int STATE_HALF_PIXEL_WIDTH = 0;
unsigned int STATE_HALF_PIXEL_HEIGHT = 0;



bool InitializeGCUniforms ()
{
	STATE_MODEL_MATRIX = AddUniform ("STATE_MODEL_MATRIX", 16);
	STATE_VIEW_MATRIX = AddUniform ("STATE_VIEW_MATRIX", 16);
	STATE_PROJECTION_MATRIX = AddUniform ("STATE_PROJECTION_MATRIX", 16);
	STATE_MODELVIEW_MATRIX = AddUniform ("STATE_MODELVIEW_MATRIX", 16);
	STATE_MODELVIEWPROJECTION_MATRIX = AddUniform ("STATE_MODELVIEWPROJECTION_MATRIX", 16);
	STATE_MODELVIEW_INVERSE_MATRIX = AddUniform ("STATE_MODELVIEW_INVERSE_MATRIX", 16);
	STATE_AUX_MATRIX = AddUniform("STATE_AUX_MATRIX", 16);

	// texture matrix
	STATE_TEXTURE0_MATRIX = AddUniform ("STATE_TEXTURE0_MATRIX", 16);
	STATE_TEXTURE1_MATRIX = AddUniform ("STATE_TEXTURE1_MATRIX", 16);
	STATE_TEXTURE2_MATRIX = AddUniform ("STATE_TEXTURE2_MATRIX", 16);
	STATE_TEXTURE3_MATRIX = AddUniform ("STATE_TEXTURE3_MATRIX", 16);
	STATE_TEXTURE4_MATRIX = AddUniform ("STATE_TEXTURE4_MATRIX", 16);
	STATE_TEXTURE5_MATRIX = AddUniform ("STATE_TEXTURE5_MATRIX", 16);
	STATE_TEXTURE6_MATRIX = AddUniform ("STATE_TEXTURE6_MATRIX", 16);
	STATE_TEXTURE7_MATRIX = AddUniform ("STATE_TEXTURE7_MATRIX", 16);

	// texture projection
	STATE_TEXTURE_PROJECTION_MATRIX = AddUniform ("STATE_TEXTURE_PROJECTION_MATRIX", 16);
	STATE_PROJECTOR_MVP = AddUniform ("STATE_PROJECTOR_MVP", 16);
	STATE_PROJECTOR_POS = AddUniform ("STATE_PROJECTOR_POS", 3);
	STATE_LIGHTMAP_POWER = AddUniform ("STATE_LIGHTMAP_POWER", 1);

	// Bone Matrix (MAX_BONES * float3x4)
	STATE_BONE_MATRIX = AddUniform ("STATE_BONE_MATRIX", MAX_BONES * 12);

	// lights
	STATE_LIGHT0_POS = AddUniform ("STATE_LIGHT0_POS", 3);
	STATE_LIGHT0_WPOS = AddUniform ("STATE_LIGHT0_WPOS", 3);
	STATE_LIGHT0_DIR = AddUniform ("STATE_LIGHT0_DIR", 3);
	STATE_LIGHT0_AMBIENT = AddUniform ("STATE_LIGHT0_AMBIENT", 4);
	STATE_LIGHT0_DIFFUSE = AddUniform ("STATE_LIGHT0_DIFFUSE", 4);
	STATE_LIGHT0_SPECULAR = AddUniform ("STATE_LIGHT0_SPECULAR", 4);
	STATE_LIGHT0_INNER = AddUniform ("STATE_LIGHT0_INNER", 1);
	STATE_LIGHT0_OUTER = AddUniform ("STATE_LIGHT0_OUTER", 1);
	STATE_LIGHT0_ATTEN_START = AddUniform ("STATE_LIGHT0_ATTEN_START", 1);
	STATE_LIGHT0_ATTEN_END = AddUniform ("STATE_LIGHT0_ATTEN_END", 1);

	STATE_LIGHT1_POS = AddUniform ("STATE_LIGHT1_POS", 3);
	STATE_LIGHT1_WPOS = AddUniform ("STATE_LIGHT1_WPOS", 3);
	STATE_LIGHT1_DIR = AddUniform ("STATE_LIGHT1_DIR", 3);
	STATE_LIGHT1_AMBIENT = AddUniform ("STATE_LIGHT1_AMBIENT", 4);
	STATE_LIGHT1_DIFFUSE = AddUniform ("STATE_LIGHT1_DIFFUSE", 4);
	STATE_LIGHT1_SPECULAR = AddUniform ("STATE_LIGHT1_SPECULAR", 4);
	STATE_LIGHT1_INNER = AddUniform ("STATE_LIGHT1_INNER", 1);
	STATE_LIGHT1_OUTER = AddUniform ("STATE_LIGHT1_OUTER", 1);
	STATE_LIGHT1_ATTEN_START = AddUniform ("STATE_LIGHT0_ATTEN_START", 1);
	STATE_LIGHT1_ATTEN_END = AddUniform ("STATE_LIGHT0_ATTEN_END", 1);

	STATE_LIGHT2_POS = AddUniform ("STATE_LIGHT2_POS", 3);
	STATE_LIGHT2_WPOS = AddUniform ("STATE_LIGHT2_WPOS", 3);
	STATE_LIGHT2_DIR = AddUniform ("STATE_LIGHT2_DIR", 3);
	STATE_LIGHT2_AMBIENT = AddUniform ("STATE_LIGHT2_AMBIENT", 4);
	STATE_LIGHT2_DIFFUSE = AddUniform ("STATE_LIGHT2_DIFFUSE", 4);
	STATE_LIGHT2_SPECULAR = AddUniform ("STATE_LIGHT2_SPECULAR", 4);
	STATE_LIGHT2_INNER = AddUniform ("STATE_LIGHT2_INNER", 1);
	STATE_LIGHT2_OUTER = AddUniform ("STATE_LIGHT2_OUTER", 1);
	STATE_LIGHT2_ATTEN_START = AddUniform ("STATE_LIGHT0_ATTEN_START", 1);
	STATE_LIGHT2_ATTEN_END = AddUniform ("STATE_LIGHT0_ATTEN_END", 1);

	STATE_LIGHT3_POS = AddUniform ("STATE_LIGHT3_POS", 3);
	STATE_LIGHT3_WPOS = AddUniform ("STATE_LIGHT3_WPOS", 3);
	STATE_LIGHT3_DIR = AddUniform ("STATE_LIGHT3_DIR", 3);
	STATE_LIGHT3_AMBIENT = AddUniform ("STATE_LIGHT3_AMBIENT", 4);
	STATE_LIGHT3_DIFFUSE = AddUniform ("STATE_LIGHT3_DIFFUSE", 4);
	STATE_LIGHT3_SPECULAR = AddUniform ("STATE_LIGHT3_SPECULAR", 4);
	STATE_LIGHT3_INNER = AddUniform ("STATE_LIGHT3_INNER", 1);
	STATE_LIGHT3_OUTER = AddUniform ("STATE_LIGHT3_OUTER", 1);
	STATE_LIGHT3_ATTEN_START = AddUniform ("STATE_LIGHT0_ATTEN_START", 1);
	STATE_LIGHT3_ATTEN_END = AddUniform ("STATE_LIGHT0_ATTEN_END", 1);

	// material
	STATE_MATERIAL_AMBIENT = AddUniform ("STATE_MATERIAL_AMBIENT", 4);
	STATE_MATERIAL_DIFFUSE = AddUniform ("STATE_MATERIAL_DIFFUSE", 4);
	STATE_MATERIAL_SPECULAR = AddUniform ("STATE_MATERIAL_SPECULAR", 4);
	STATE_MATERIAL_EMISSIVE = AddUniform ("STATE_MATERIAL_EMISSIVE", 4);
	STATE_MATERIAL_POWER = AddUniform ("STATE_MATERIAL_POWER", 1);

	STATE_HALF_PIXEL_WIDTH = AddUniform ("STATE_HALF_PIXEL_WIDTH", 1);
	STATE_HALF_PIXEL_HEIGHT = AddUniform ("STATE_HALF_PIXEL_HEIGHT", 1);

	return true;
}

void ReleaseGCUniforms ()
{
	DeleteUniform (STATE_MODEL_MATRIX);
	DeleteUniform (STATE_VIEW_MATRIX);
	DeleteUniform (STATE_PROJECTION_MATRIX);
	DeleteUniform (STATE_MODELVIEW_MATRIX);
	DeleteUniform (STATE_MODELVIEWPROJECTION_MATRIX);
	DeleteUniform (STATE_MODELVIEW_INVERSE_MATRIX);
	DeleteUniform (STATE_AUX_MATRIX);

	// texture matrix
	DeleteUniform (STATE_TEXTURE0_MATRIX);
	DeleteUniform (STATE_TEXTURE1_MATRIX);
	DeleteUniform (STATE_TEXTURE2_MATRIX);
	DeleteUniform (STATE_TEXTURE3_MATRIX);
	DeleteUniform (STATE_TEXTURE4_MATRIX);
	DeleteUniform (STATE_TEXTURE5_MATRIX);
	DeleteUniform (STATE_TEXTURE6_MATRIX);
	DeleteUniform (STATE_TEXTURE7_MATRIX);

	// texture projection
	DeleteUniform (STATE_TEXTURE_PROJECTION_MATRIX);
	DeleteUniform (STATE_PROJECTOR_MVP);
	DeleteUniform (STATE_PROJECTOR_POS);
	DeleteUniform (STATE_LIGHTMAP_POWER);

	// Bone Matrix (MAX_BONES * float3x4)
	DeleteUniform (STATE_BONE_MATRIX);

	// lights
	DeleteUniform (STATE_LIGHT0_POS);
	DeleteUniform (STATE_LIGHT0_WPOS);
	DeleteUniform (STATE_LIGHT0_DIR);
	DeleteUniform (STATE_LIGHT0_AMBIENT);
	DeleteUniform (STATE_LIGHT0_DIFFUSE);
	DeleteUniform (STATE_LIGHT0_SPECULAR);
	DeleteUniform (STATE_LIGHT0_INNER);
	DeleteUniform (STATE_LIGHT0_OUTER);
	DeleteUniform (STATE_LIGHT0_ATTEN_START);
	DeleteUniform (STATE_LIGHT0_ATTEN_END);

	DeleteUniform (STATE_LIGHT1_POS);
	DeleteUniform (STATE_LIGHT1_WPOS);
	DeleteUniform (STATE_LIGHT1_DIR);
	DeleteUniform (STATE_LIGHT1_AMBIENT);
	DeleteUniform (STATE_LIGHT1_DIFFUSE);
	DeleteUniform (STATE_LIGHT1_SPECULAR);
	DeleteUniform (STATE_LIGHT1_INNER);
	DeleteUniform (STATE_LIGHT1_OUTER);
	DeleteUniform (STATE_LIGHT1_ATTEN_START);
	DeleteUniform (STATE_LIGHT1_ATTEN_END);

	DeleteUniform (STATE_LIGHT2_POS);
	DeleteUniform (STATE_LIGHT2_WPOS);
	DeleteUniform (STATE_LIGHT2_DIR);
	DeleteUniform (STATE_LIGHT2_AMBIENT);
	DeleteUniform (STATE_LIGHT2_DIFFUSE);
	DeleteUniform (STATE_LIGHT2_SPECULAR);
	DeleteUniform (STATE_LIGHT2_INNER);
	DeleteUniform (STATE_LIGHT2_OUTER);
	DeleteUniform (STATE_LIGHT2_ATTEN_START);
	DeleteUniform (STATE_LIGHT2_ATTEN_END);

	DeleteUniform (STATE_LIGHT3_POS);
	DeleteUniform (STATE_LIGHT3_WPOS);
	DeleteUniform (STATE_LIGHT3_DIR);
	DeleteUniform (STATE_LIGHT3_AMBIENT);
	DeleteUniform (STATE_LIGHT3_DIFFUSE);
	DeleteUniform (STATE_LIGHT3_SPECULAR);
	DeleteUniform (STATE_LIGHT3_INNER);
	DeleteUniform (STATE_LIGHT3_OUTER);
	DeleteUniform (STATE_LIGHT3_ATTEN_START);
	DeleteUniform (STATE_LIGHT3_ATTEN_END);

	// material
	DeleteUniform (STATE_MATERIAL_AMBIENT);
	DeleteUniform (STATE_MATERIAL_DIFFUSE);
	DeleteUniform (STATE_MATERIAL_SPECULAR);
	DeleteUniform (STATE_MATERIAL_EMISSIVE);
	DeleteUniform (STATE_MATERIAL_POWER);

	DeleteUniform (STATE_HALF_PIXEL_WIDTH);
	DeleteUniform (STATE_HALF_PIXEL_HEIGHT);


	STATE_MODEL_MATRIX = 0;
	STATE_VIEW_MATRIX = 0;
	STATE_PROJECTION_MATRIX = 0;
	STATE_MODELVIEW_MATRIX = 0;
	STATE_MODELVIEWPROJECTION_MATRIX = 0;
	STATE_MODELVIEW_INVERSE_MATRIX = 0;

	// texture matrix
	STATE_TEXTURE0_MATRIX = 0;
	STATE_TEXTURE1_MATRIX = 0;
	STATE_TEXTURE2_MATRIX = 0;
	STATE_TEXTURE3_MATRIX = 0;
	STATE_TEXTURE4_MATRIX = 0;
	STATE_TEXTURE5_MATRIX = 0;
	STATE_TEXTURE6_MATRIX = 0;
	STATE_TEXTURE7_MATRIX = 0;

	// texture projection
	STATE_TEXTURE_PROJECTION_MATRIX = 0;
	STATE_PROJECTOR_MVP = 0;
	STATE_PROJECTOR_POS = 0;
	STATE_LIGHTMAP_POWER = 0;

	// Bone Matrix (MAX_BONES * float3x4)
	STATE_BONE_MATRIX = 0;

	// lights
	STATE_LIGHT0_POS = 0;
	STATE_LIGHT0_DIR = 0;
	STATE_LIGHT0_AMBIENT = 0;
	STATE_LIGHT0_DIFFUSE = 0;
	STATE_LIGHT0_SPECULAR = 0;
	STATE_LIGHT0_INNER = 0;
	STATE_LIGHT0_OUTER = 0;
	STATE_LIGHT0_ATTEN_START = 0;
	STATE_LIGHT0_ATTEN_END = 0;

	STATE_LIGHT1_POS = 0;
	STATE_LIGHT1_DIR = 0;
	STATE_LIGHT1_AMBIENT = 0;
	STATE_LIGHT1_DIFFUSE = 0;
	STATE_LIGHT1_SPECULAR = 0;
	STATE_LIGHT1_INNER = 0;
	STATE_LIGHT1_OUTER = 0;
	STATE_LIGHT1_ATTEN_START = 0;
	STATE_LIGHT1_ATTEN_END = 0;

	STATE_LIGHT2_POS = 0;
	STATE_LIGHT2_DIR = 0;
	STATE_LIGHT2_AMBIENT = 0;
	STATE_LIGHT2_DIFFUSE = 0;
	STATE_LIGHT2_SPECULAR = 0;
	STATE_LIGHT2_INNER = 0;
	STATE_LIGHT2_OUTER = 0;
	STATE_LIGHT2_ATTEN_START = 0;
	STATE_LIGHT2_ATTEN_END = 0;

	STATE_LIGHT3_POS = 0;
	STATE_LIGHT3_DIR = 0;
	STATE_LIGHT3_AMBIENT = 0;
	STATE_LIGHT3_DIFFUSE = 0;
	STATE_LIGHT3_SPECULAR = 0;
	STATE_LIGHT3_INNER = 0;
	STATE_LIGHT3_OUTER = 0;
	STATE_LIGHT3_ATTEN_START = 0;
	STATE_LIGHT3_ATTEN_END = 0;

	// material
	STATE_MATERIAL_AMBIENT = 0;
	STATE_MATERIAL_DIFFUSE = 0;
	STATE_MATERIAL_SPECULAR = 0;
	STATE_MATERIAL_EMISSIVE = 0;
	STATE_MATERIAL_POWER = 0;

	STATE_HALF_PIXEL_WIDTH = 0;
	STATE_HALF_PIXEL_HEIGHT = 0;

}


