#ifndef STATE_CACHE_H
#define STATE_CACHE_H

#include <gc.h>
#include <builddefs.h>

extern unsigned int STATE_MODEL_MATRIX;						//16
extern unsigned int STATE_VIEW_MATRIX;						//16
extern unsigned int STATE_PROJECTION_MATRIX;				//16
extern unsigned int STATE_MODELVIEW_MATRIX;					//16
extern unsigned int STATE_MODELVIEWPROJECTION_MATRIX;		//16
extern unsigned int STATE_MODELVIEW_INVERSE_MATRIX;			//16
extern unsigned int STATE_AUX_MATRIX;						//16
	// texture matrix
extern unsigned int STATE_TEXTURE0_MATRIX;					//16
extern unsigned int STATE_TEXTURE1_MATRIX;					//16
extern unsigned int STATE_TEXTURE2_MATRIX;					//16
extern unsigned int STATE_TEXTURE3_MATRIX;					//16
extern unsigned int STATE_TEXTURE4_MATRIX;					//16
extern unsigned int STATE_TEXTURE5_MATRIX;					//16
extern unsigned int STATE_TEXTURE6_MATRIX;					//16
extern unsigned int STATE_TEXTURE7_MATRIX;					//16

	// texture projection
extern unsigned int STATE_TEXTURE_PROJECTION_MATRIX;		//16
extern unsigned int STATE_PROJECTOR_MVP;					//16
extern unsigned int STATE_PROJECTOR_POS;					//3
extern unsigned int STATE_LIGHTMAP_POWER;					//1

	// Bone Matrix (MAX_BONES * float3x4)
extern unsigned int STATE_BONE_MATRIX;						//720

	// lights
extern unsigned int STATE_LIGHT0_POS;						//3
extern unsigned int STATE_LIGHT0_WPOS;						//3
extern unsigned int STATE_LIGHT0_DIR;						//3
extern unsigned int STATE_LIGHT0_AMBIENT;					//4
extern unsigned int STATE_LIGHT0_DIFFUSE;					//4
extern unsigned int STATE_LIGHT0_SPECULAR;					//4
extern unsigned int STATE_LIGHT0_INNER;						//1
extern unsigned int STATE_LIGHT0_OUTER;						//1
extern unsigned int STATE_LIGHT0_ATTEN_START;				//1
extern unsigned int STATE_LIGHT0_ATTEN_END;					//1

extern unsigned int STATE_LIGHT1_POS;						//3
extern unsigned int STATE_LIGHT1_WPOS;						//3
extern unsigned int STATE_LIGHT1_DIR;						//3
extern unsigned int STATE_LIGHT1_AMBIENT;					//4
extern unsigned int STATE_LIGHT1_DIFFUSE;					//4
extern unsigned int STATE_LIGHT1_SPECULAR;					//4
extern unsigned int STATE_LIGHT1_INNER;						//1
extern unsigned int STATE_LIGHT1_OUTER;						//1
extern unsigned int STATE_LIGHT1_ATTEN_START;				//1
extern unsigned int STATE_LIGHT1_ATTEN_END;					//1

extern unsigned int STATE_LIGHT2_POS;						//3
extern unsigned int STATE_LIGHT2_WPOS;						//3
extern unsigned int STATE_LIGHT2_DIR;						//3
extern unsigned int STATE_LIGHT2_AMBIENT;					//4
extern unsigned int STATE_LIGHT2_DIFFUSE;					//4
extern unsigned int STATE_LIGHT2_SPECULAR;					//4
extern unsigned int STATE_LIGHT2_INNER;						//1
extern unsigned int STATE_LIGHT2_OUTER;						//1
extern unsigned int STATE_LIGHT2_ATTEN_START;				//1
extern unsigned int STATE_LIGHT2_ATTEN_END;					//1

extern unsigned int STATE_LIGHT3_POS;						//3
extern unsigned int STATE_LIGHT3_WPOS;						//3
extern unsigned int STATE_LIGHT3_DIR;						//3
extern unsigned int STATE_LIGHT3_AMBIENT;					//4
extern unsigned int STATE_LIGHT3_DIFFUSE;					//4
extern unsigned int STATE_LIGHT3_SPECULAR;					//4
extern unsigned int STATE_LIGHT3_INNER;						//1
extern unsigned int STATE_LIGHT3_OUTER;						//1
extern unsigned int STATE_LIGHT3_ATTEN_START;				//1
extern unsigned int STATE_LIGHT3_ATTEN_END;					//1

	// material
extern unsigned int STATE_MATERIAL_AMBIENT;					//4
extern unsigned int STATE_MATERIAL_DIFFUSE;					//4
extern unsigned int STATE_MATERIAL_SPECULAR;				//4
extern unsigned int STATE_MATERIAL_EMISSIVE;				//4
extern unsigned int STATE_MATERIAL_POWER;					//1

extern unsigned int STATE_HALF_PIXEL_WIDTH;					//1
extern unsigned int STATE_HALF_PIXEL_HEIGHT;				//1

bool InitializeGCUniforms ();
void ReleaseGCUniforms ();



#endif //STATE_CACHE_H

