#ifndef TEXT_H
#define TEXT_H

#include <math3d.h>
#include "color.h"

#if defined(WIN32) || defined(__WIN32__)
#include <windows.h>
#endif

unsigned int CreateFont(const char *fname, int font_size);
void DeleteFont(unsigned int fid);
unsigned int GetFont(const char *fname, int sz);
bool BindFont(unsigned int fid);


void SetTextPos(const Vector2 &pos);
Vector2 GetTextPos();

void TextLineAdvance(int adv = 1);
void TextCRet();

void SetTextSize(float sz);
float GetTextSize();

void SetTextColor(const Color &col);
Color GetTextColor();

float PrintChar(char c);
float PrintString(const char *text, bool standalone = true);
void PrintStringLines(const char **str, int lines);

float GetMaxDescent();
float GetTextWidth(const char *str);

float GetLineAdvance();

#endif	// TEXT_H
