#ifndef VBUFFER_H
#define VBUFFER_H

#include <builddefs.h>
#include "gctypes.h"
#include "vertexformat.h"

#define INDEX_SIZE	4

#define BUFFER_DYNAMIC		true
#define BUFFER_STATIC		false

unsigned int CreateVertexBuffer (const VertexFormat &vf, unsigned int elements_count, bool dynamic = false);
void DeleteVertexBuffer (unsigned int id);
bool BindVertexBuffer (unsigned int id);
void *LockVertexBuffer (unsigned int id, unsigned int start_vertex, unsigned int vertex_count);
void UnlockVertexBuffer (unsigned int id);
VertexFormat GetVertexFormat (unsigned int id);

unsigned int CreateIndexBuffer (unsigned int indices_count, bool dynamic = false);
void DeleteIndexBuffer (unsigned int id);
bool BindIndexBuffer (unsigned int id);
void *LockIndexBuffer (unsigned int id, unsigned int start, unsigned int count);
void UnlockIndexBuffer (unsigned int id);

bool RenderPrimitives (PrimitiveType pt, unsigned int start_vertex, unsigned int primitive_count);
bool RenderIndexedPrimitives (PrimitiveType pt, unsigned int start_index, unsigned int primitive_count, unsigned int start_vertex, unsigned int vertices_count);

#endif //VBUFFER_H

