#ifndef FULL_MATERIAL_H
#define FULL_MATERIAL_H

#include <math3d.h>
#include <lighting.h>

enum FMTEX_TYPE {
	FMTT_DIFFUSE,
	FMTT_SPECULAR,
	FMTT_LIGHTMAP,
	FMTT_EMISSIVE,
	FMTT_NORMAL,
	FMTT_COUNT
};

struct FMTexture {
	unsigned int tex_id;
	char *fname;
};

class FullMaterial {
public:
	Material gc_mat;
	FMTexture tex[FMTT_COUNT];

	FullMaterial();
	~FullMaterial();

	void SetTexFilename(unsigned int tex_type, const char *name);
	void ReleaseTextures();
	bool CreateTextures();

	void Bind() const;
};

FullMaterial *GetDefaultMaterial();

#endif //FULL_MATERIAL_H

