// prbars.cpp

#include "prbars.h"
#include <gc.h>
#include <immed.h>
#include <errlog.h>

// FrBar class implementation
FrBar::FrBar()
{

}

FrBar::~FrBar()
{

}

bool FrBar::Init()
{
	return true;
}

void FrBar::Destroy()
{

}

void FrBar::Update(float task, float all, const char *msg)
{
	if (msg) Info(msg);
	BeginScene();
	SetClearColor(Color(0, 0, 0, 0));
	SetClearDepth(1.0);
	Clear();

	SetLighting(false);
	SetDepthTest(false);

	ImFixedFunction(true);
	Vector2 outer(0.1f, 0.4f);
	Vector2 inner = outer + Vector2(0.05f, 0.05f);
	
	Vector2 outer_end = Vector2(1, 1) - outer;
	Vector2 inner_end = Vector2(1, 1) - inner;

	Vector2 height = Vector2(0, outer_end.y - outer.y) * 3.0f / 4.0f;

	ImOverlay(outer - height, outer_end - height, Color(1, 1, 1, 1));
	ImOverlay(inner - height, inner_end - height, Color(0, 0, 0, 1));
	ImOverlay(inner - height, Vector2(inner.x + (inner_end.x - inner.x) * 
		all, inner_end.y) - height, Color(0, 0, 1, 1));

	ImOverlay(outer + height, outer_end + height, Color(1, 1, 1, 1));
	ImOverlay(inner + height, inner_end + height, Color(0, 0, 0, 1));
	ImOverlay(inner + height, Vector2(inner.x + (inner_end.x - inner.x) * 
		task, inner_end.y) + height, Color(0, 0, 1, 1));

	EndScene();
	Flip();
}
