// sdrgen_simple.h
// shader generator for simple renderer

#ifndef _SDR_GEN_SIMPLE_
#define _SDR_GEN_SIMPLE_

// bit 0 : rigid / skinned object
#define SGS_RIGID			0
#define SGS_SKIN			1

// bits 1-2 : light type
#define SGS_AMBIENT			(0 << 1)
#define SGS_OMNI			(1 << 1)
#define SGS_SPOT			(2 << 1)
#define SGS_DIRECTIONAL		(3 << 1)

// bit 3 : shadows
#define SGS_NOSHADOWS		(0 << 3)
#define SGS_SHADOWS			(1 << 3)

// bit 4 : fog
#define SGS_NOFOG			(0 << 4)
#define SGS_FOG				(1 << 4)

// bits 5-6 : shading mode
#define SGS_FLAT			(0 << 5)
#define SGS_NORMALMAP		(1 << 5)
#define SGS_PARALLAX		(2 << 5)
#define SGS_RELIEF			(3 << 5)

#define SGS_MAX_SHADERS		64

//unsigned int SGS_GetShader(unsigned int mask);



#endif // ndef _SDR_GEN_SIMPLE_

