// texman.h

#ifndef _TEXMAN_H_
#define _TEXMAN_H_

#include <textures.h>

unsigned int CreateTextureFromFile(const char *filename, TextureFormat fmt, bool mip);
unsigned int CreateCubeTextureFromFile(const char *filename, TextureFormat fmt, bool mip);

// get a managed texture (or create it and add it to managed)
unsigned int GetTexture(const char *filename, unsigned int priority = 1);

void SetTexturePriority(const char *filename, unsigned int priority);
void SetTexturePriority(unsigned int tex_id, unsigned int priority);

// estimated texture memory (for all managed textures)
unsigned int TexMemoryUsed();

// release all managed textures
void ReleaseTextures();
void ReleaseTexture(const char *filename);
void ReleaseTexture(unsigned int tex_id);

unsigned int FitTextures(unsigned int quality, unsigned int bytes);

// texman state
void SetDefTexFormat(TextureFormat fmt = TFMT_32);
void SetDefMipmaps(bool enable = true);

#endif // ndef _TEXMAN_H_
