#ifndef _CONVIMG_H_
#define _CONVIMG_H_

#include <gctypes.h>

#ifdef __cplusplus
extern "C" {
#else
typedef unsigned char bool;
#endif

/* generic conversion */
bool convert(const void *psrc, void *pdst, unsigned int w, unsigned int h, enum TextureFormat src_fmt, enum TextureFormat dst_fmt);

/* format conversion */
bool conv_32_to_24(const void *psrc, void *pdst, unsigned int w, unsigned int h);
bool conv_24_to_32(const void *psrc, void *pdst, unsigned int w, unsigned int h);
bool conv_32_to_16(const void *psrc, void *pdst, unsigned int w, unsigned int h);
bool conv_16_to_32(const void *psrc, void *pdst, unsigned int w, unsigned int h);
bool conv_32_to_15(const void *psrc, void *pdst, unsigned int w, unsigned int h);
bool conv_15_to_32(const void *psrc, void *pdst, unsigned int w, unsigned int h);
bool conv_32_to_8(const void *psrc, void *pdst, unsigned int w, unsigned int h);
bool conv_8_to_32(const void *psrc, void *pdst, unsigned int w, unsigned int h);
bool conv_32_to_comp24(const void *psrc, void *pdst, unsigned int w, unsigned int h);
bool conv_comp24_to_32(const void *psrc, void *pdst, unsigned int w, unsigned int h);
bool conv_32_to_comp32(const void *psrc, void *pdst, unsigned int w, unsigned int h);
bool conv_comp32_to_32(const void *psrc, void *pdst, unsigned int w, unsigned int h);

/* resampling */
bool resample(const unsigned int *psrc, unsigned int *pdst, unsigned int sw, unsigned int sh, unsigned int dw, unsigned int dh);

/* image size in bytes */
unsigned int img_size(unsigned int w, unsigned int h, enum TextureFormat fmt);

#ifdef __cplusplus
}
#endif

#endif /* ndef _CONVIMG_H_ */
