#include "libimage.h"
#include "image.h"

Image::Image()
{
	format = IFMT_RGBA32;
	pixels = 0;
	width = height = 0;
	tex_id = 0;
	tex_destr = 0;
}

Image::~Image()
{
	ImgFreeImage(pixels);

	if(tex_destr) {
		tex_destr(tex_id);
	}
}

bool Image::Load(const char *fname)
{
	if(!(pixels = ImgLoadImage(fname, &width, &height))) {
		return false;
	}
	return true;
}

unsigned int Image::GetWidth() const
{
	return width;
}

unsigned int Image::GetHeight() const
{
	return height;
}

const void *Image::GetPixels() const
{
	return pixels;
}

void *Image::GetPixels()
{
	return pixels;
}

void Image::SetTextureDestructor(void (*tdestr)(unsigned int))
{
	tex_destr = tdestr;
}
