#ifndef LIB_IMAGE_H
#define LIB_IMAGE_H

enum ImageFormat {
	IFMT_RGBA32
};

class Image {
protected:
	ImageFormat format;
	void *pixels;
	unsigned int width, height;

	void (*tex_destr)(unsigned int);

public:
	unsigned int tex_id;	/* optional, not created by default */

	Image();
	~Image();

	bool Load(const char *fname);

	unsigned int GetWidth() const;
	unsigned int GetHeight() const;

	const void *GetPixels() const;
	void *GetPixels();

	void SetTextureDestructor(void (*tdestr)(unsigned int));
};


#endif //LIB_IMAGE_H

