#include <stack>
#include "libsys.h"

std::stack<Handlers> sys_handlers;

#define HANDLE_EMPTY()	if(sys_handlers.empty()) sys_handlers.push(Handlers())

void SysSetDisplayHandler(SysDisplayHandler handler)
{
	HANDLE_EMPTY();
	sys_handlers.top().display = handler;
}

void SysSetKeyboardHandler(SysKeyboardHandler handler)
{
	HANDLE_EMPTY();
	sys_handlers.top().keyb = handler;
}

void SysSetMotionHandler(SysMotionHandler handler)
{
	HANDLE_EMPTY();
	sys_handlers.top().motion = handler;
}

void SysSetButtonHandler(SysButtonHandler handler)
{
	HANDLE_EMPTY();
	sys_handlers.top().button = handler;
}

void SysSetResizeHandler(SysResizeHandler handler)
{
	HANDLE_EMPTY();
	sys_handlers.top().resize = handler;
}

void SysSetXPadHandler(SysXPadHandler handler)
{
	HANDLE_EMPTY();
	sys_handlers.top().xpad = handler;
}

SysDisplayHandler SysGetDisplayHandler()
{
	return sys_handlers.top().display;
}

SysKeyboardHandler SysGetKeyboardHandler()
{
	return sys_handlers.top().keyb;
}

SysMotionHandler SysGetMotionHandler()
{
	return sys_handlers.top().motion;
}

SysButtonHandler SysGetButtonHandler()
{
	return sys_handlers.top().button;
}

SysResizeHandler SysGetResizeHandler()
{
	return sys_handlers.top().resize;
}

SysXPadHandler SysGetXPadHandler()
{
	return sys_handlers.top().xpad;
}


void SysPushHandlers()
{
	sys_handlers.push(sys_handlers.top());
}

bool SysPopHandlers()
{
	if(sys_handlers.size() <= 1) {
		// always have at least one handler set in there
		return false;
	}
	sys_handlers.pop();
	return true;
}
