// xpad.h

#ifndef _XPAD_H_
#define _XPAD_H_

enum XPadKeys
{
	// pad
	XPAD_LEFT,
	XPAD_RIGHT,
	XPAD_UP,
	XPAD_DOWN,

	// func
	XPAD_BACK,
	XPAD_START,

	// buttons
	XPAD_A,
	XPAD_B,
	XPAD_X,
	XPAD_Y,
	XPAD_L_THUMB,
	XPAD_R_THUMB,
	XPAD_L_SHOULDER,
	XPAD_R_SHOULDER
};

enum XPadAnalogs
{
	XPAD_L_THUMB_X,
	XPAD_L_THUMB_Y,
	XPAD_R_THUMB_X,
	XPAD_R_THUMB_Y,
	XPAD_L_TRIGGER,
	XPAD_R_TRIGGER
};

enum XPadEventType
{
	XPAD_NONE,
	XPAD_PRESSED,
	XPAD_RELEASED,
	XPAD_CONNECTED,
	XPAD_DISCONNECTED,
	XPAD_MOVED
};

struct XPadState
{
	bool connected;
	bool keys[14];
	float analogs[6];
};

struct XPadEvent
{
	unsigned int which;
	XPadEventType type;
	XPadKeys key;
	XPadAnalogs analog;
	float move;
};

void UpdateXPad();
bool GetXPadEvent(XPadEvent &message);
XPadState GetXPadState(unsigned int which);
void SetXPadSpeed(unsigned int which, float left, float right);

#endif // ndef _XPAD_H_
