#include "utk_arrow.h"

namespace utk {

Arrow::Arrow(ArrowOrientation orientation)
{
	this->orientation = orientation;
	set_size(15, 15);
	set_color(utk::Color(0, 0, 0));
}

Arrow::~Arrow() {}

void Arrow::set_orientation(ArrowOrientation orientation)
{
	this->orientation = orientation;
}

ArrowOrientation Arrow::get_orientation() const
{
	return orientation;
}

void Arrow::draw() const
{
	IVec2	gpos = get_global_pos();

	gfx::color_clamp(color.r, color.g, color.b, color.a);
	gfx::arrow(gpos.x + size.x/2, gpos.y + size.y/2, orientation);
}

Arrow *create_arrow(Widget *parent, ArrowOrientation orientation)
{
	Arrow	*arrow = new Arrow(orientation);
	if (parent) parent->add_child(arrow);
	return arrow;
}

}
