#ifndef UTK_COMBOBOX_H_
#define UTK_COMBOBOX_H_

#include <utk_events.h>
#include <utk_button.h>
#include <utk_entry.h>
#include <utk_popup.h>
#include <utk_listbox.h>
#include <utk_container.h>

namespace utk {

class ComboBox : public utk::HBox
{
protected:
	Entry	*entry;
	Button	*reveal;
	Popup	*list_popup;
	ListBox	*list;

public:
	ComboBox();
	virtual ~ComboBox();

	virtual void set_size(int w, int h);

	virtual void show_list();

	virtual void add_item(const char *text);
	virtual void add_item(utk::Widget *widget);
	virtual void remove_item(int pos = -1);

	virtual int get_selected() const;
	virtual const char *get_selected_text() const;

	virtual void text_to_selected_item();

	virtual void set_readonly(bool readonly);
	virtual bool is_readonly() const;
};

ComboBox *create_combobox(utk::Widget *parent);

}

#endif
