#include <string>
#include <utk_widget.h>
#include <utk_types.h>

#ifndef UTK_DRAWABLE_H_
#define UTK_DRAWABLE_H_

namespace utk {

class Drawable : public Widget {
protected:
	Color color, light_color, dark_color;
	int border;
	std::string text;

public:
	Drawable();
	virtual ~Drawable();

	virtual void set_text(const char *text);
	virtual const char *get_text() const;

	virtual void set_color(int r, int g, int b, int a = 255);
	virtual void set_color(const Color &col);
	virtual const Color &get_color() const;

	virtual void set_alpha(int a);
	virtual int get_alpha() const;

	virtual void set_border(int border);
	virtual int get_border() const;
};

}

#endif	// UTK_DRAWABLE_H_
