#ifndef UTK_ENTRY_H_
#define UTK_ENTRY_H_

#include <utk_drawable.h>
#include <utk_events.h>

namespace utk {

class Entry : public Drawable {
protected:
	int cursor;
	int vscroll;
	bool readonly;
	
	int cursor_from_x(int x) const;
	int x_from_cursor(int c) const;
	
	void scroll_to_cursor();

public:
	Entry(const char *txt = 0, utk::Callback cb = 0);
	virtual ~Entry();

	virtual Widget *handle_event(Event *event);

	virtual void draw() const;

	virtual void set_readonly(bool readonly);
	virtual bool is_readonly() const;
};

Entry *create_entry(Widget *parent, const char *text, int width = 100, Callback func = 0, void *cdata = 0);
void destroy_entry(Entry *en);

}

#endif	// UTK_ENTRY_H_
