// cullable.cpp

#include "cullable.h"

// helper
CullableList ConcatCullLists(const CullableList &a, const CullableList &b)
{
	if (!a.size()) return b;
	if (!b.size()) return a;

	CullableList ret;
	for (unsigned int i=0; i<a.size(); i++)
	{
		ret.push_back(a[i]);
	}
	for (unsigned int i=0; i<b.size(); i++)
	{
		ret.push_back(b[i]);
	}

	return ret;
}

Cullable::Cullable()
{
	frame = 0;
}

Cullable::~Cullable()
{
}

// for the base class, return the bounding box triangles
unsigned int Cullable::GetCullableTriangleCount() const
{
	return 12;	
}

Triangle Cullable::GetCullableTriangle(unsigned int i) const
{
	Quad q = GetSpacetimeBoundingBox().GetQuad(i / 2);
	return q.GetTriangle(i % 2);
}

bool Cullable::OwnedBy(PVS *set)
{
	return owners[set];
}

void Cullable::SetOwner(PVS *owner, bool enable)
{
	owners[owner] = enable;
}

// CachedCullable class implementation
CachedCullable::CachedCullable()
{
	cullable_type = CULLABLE_MESH;
}

Box CachedCullable::GetSpacetimeBoundingBox() const
{
	return cullable_spacetime_box;
}

unsigned int CachedCullable::GetCullableType() const
{
	return cullable_type;
}
