#ifndef VIS_H
#define VIS_H

#include <vector.h>
#include <math3d.h>
#include <geom.h>
#include <camera.h>
#include "octree.h"

#define MAX_VIS_RESULT        5

struct VisResult
{
	unsigned int vis_ref [MAX_VIS_RESULT];
};

struct VisObject
{
	Box *box;
	VisResult *result;
};

class Vis
{
protected:
	std::vector<VisObject*> object_list;

	unsigned int GetFreeObject ();
public:
	Vis ();
	~Vis ();

	unsigned int AddObject (Box *box, VisResult *result);
	void RemoveObject (unsigned int vis_id);
	void ClearObjects ();
};

#endif //VIS_H

