// stat.h

#ifndef _STAT_H_
#define _STAT_H_

#include "vector.h"
#include <vector>

float Average(const std::vector<float> &ra);
std::vector<float> ExcludeDistant(const std::vector<float> &ra);
float LocalAverage(const std::vector<float> &ra);
Vector2 Average(const std::vector<Vector2> &ra);
Vector3 Average(const std::vector<Vector3> &ra);
void Split(const std::vector<float> &ra, float val, std::vector<float> &l,
		   std::vector<float> &ge);

// simple least squares
// x component is the independent variable and y is its function
// return value is a Vector2(a, b) , where a and b are the parameters
// of a linear function : y = a*x + b
Vector2 LeastSq(const std::vector<Vector2> &ra);

#endif // ndef _STAT_H_
