// log.cpp

#include "log.h"
#include <libvfs.h>
#include <stdarg.h>
#include <stdio.h>

VFS_FILE* log_fp;

void OpenLog(const char* filename)
{
#ifdef LOGGING
	log_fp = vfs_open(filename, "w+");
#endif
}

void CloseLog()
{
#ifdef LOGGING
	if (log_fp)
	{
		vfs_close(log_fp);
	}
#endif
}

void Log(const char *format, ...)
{
#ifdef LOGGING
	static char tb[1024];
	if (!log_fp)
	{
		return;
	}

	va_list arg_list;

	va_start(arg_list, format);
	sprintf(tb, format, arg_list);
	va_end(arg_list);

	vfs_printf(log_fp, tb);
	vfs_printf(log_fp, "skata %d\n", 12345);
#endif
}
