// plugin.cpp

#include "plugin.h"


// unique identifier for our new plugin
#define EXPORT_PLUGIN_CLASS_ID	Class_ID(0x6e695ac7, 0xccc3b12)
#define ANIMATION_PLUGIN_CLASS_ID Class_ID(0x2e6161d8, 0x440e4bc9)

extern HINSTANCE hinstance;

// ExportPlugin class implementation
ExportPlugin::ExportPlugin()
{
	mat_count = 0;
	curr_file_node = 0;
}


ExportPlugin::~ExportPlugin()
{
}


// Methods required for the plugin

// Number of extemsions supported
int	ExportPlugin::ExtCount()
{
	return 1;
}

// Extension #n (i.e. "3DS")
const TCHAR * ExportPlugin::Ext(int n)
{
	return "t7sce";
}

// Long ASCII description (i.e. "Autodesk 3D Studio File")
const TCHAR * ExportPlugin::LongDesc()
{
	return "SCE Track7 scene file";
}

// Short ASCII description (i.e. "3D Studio")
const TCHAR * ExportPlugin::ShortDesc()
{
	return "TRACK7 SCE";
}

// ASCII Author name
const TCHAR * ExportPlugin::AuthorName()
{
	return "Mihalis Georgoulopoulos";
}

// ASCII Copyright message
const TCHAR * ExportPlugin::CopyrightMessage()
{
	return "(c) 2006 Track7 inc\nAll rights reserved";
}

// Other message #1
const TCHAR * ExportPlugin::OtherMessage1()
{
	return "";
}

// Other message #2
const TCHAR * ExportPlugin::OtherMessage2()
{
	return "";
}

// Version number * 100 (i.e. v3.01 = 301)
unsigned int ExportPlugin::Version()
{
	return 100;
}

// Show DLL's "About..." box
void ExportPlugin::ShowAbout(HWND hWnd)
{
	MessageBox(hWnd, "Track7 scene exporter plugin\nMihalis Georgoulopoulos 2006",
		"About this plugin", 0);
}



// Returns TRUE if all option bits set are supported for this extension
BOOL ExportPlugin::SupportsOptions(int ext, DWORD options)
{
	return false;
}


// class descriptor
/////////////////////////////////////////////////////////////////////////////
class ExportPluginDesc : public ClassDesc2 
{
public:
	int IsPublic()
	{
		return TRUE;
	}

	void *Create(BOOL loading = FALSE)
	{
		return new ExportPlugin();
	}

	const TCHAR *ClassName()
	{
		return "ExportPlugin";
	}

	SClass_ID SuperClassID()
	{
		return SCENE_EXPORT_CLASS_ID;
	}
	
	Class_ID ClassID()
	{
		return EXPORT_PLUGIN_CLASS_ID;
	}

	const TCHAR* Category()
	{
		return "Category";
	}

	const TCHAR* InternalName()
	{
		return "ExportPlugin";
	}

	HINSTANCE HInstance()
	{
		return hinstance;
	}

}; // end class ExportPluginDesc

static ExportPluginDesc export_plugin_desc;
ClassDesc2* GetExportPluginDesc()
{
	return &export_plugin_desc;
}

// --------------------------------------------------------------------------
// animation plugin
// --------------------------------------------------------------------------
// ExportPlugin class implementation
AnimationPlugin::AnimationPlugin()
{
}


AnimationPlugin::~AnimationPlugin()
{
}


// Methods required for the plugin

// Number of extemsions supported
int	AnimationPlugin::ExtCount()
{
	return 1;
}

// Extension #n (i.e. "3DS")
const TCHAR * AnimationPlugin::Ext(int n)
{
	return "t7anm";
}

// Long ASCII description (i.e. "Autodesk 3D Studio File")
const TCHAR * AnimationPlugin::LongDesc()
{
	return "ANM Track7 animation file";
}

// Short ASCII description (i.e. "3D Studio")
const TCHAR * AnimationPlugin::ShortDesc()
{
	return "TRACK7 ANM";
}

// ASCII Author name
const TCHAR * AnimationPlugin::AuthorName()
{
	return "Mihalis Georgoulopoulos";
}

// ASCII Copyright message
const TCHAR * AnimationPlugin::CopyrightMessage()
{
	return "(c) 2006 Track7 inc\nAll rights reserved";
}

// Other message #1
const TCHAR * AnimationPlugin::OtherMessage1()
{
	return "";
}

// Other message #2
const TCHAR * AnimationPlugin::OtherMessage2()
{
	return "";
}

// Version number * 100 (i.e. v3.01 = 301)
unsigned int AnimationPlugin::Version()
{
	return 100;
}

// Show DLL's "About..." box
void AnimationPlugin::ShowAbout(HWND hWnd)
{
	MessageBox(hWnd, "Track7 animation exporter plugin\nMihalis Georgoulopoulos 2006",
		"About this plugin", 0);
}



// Returns TRUE if all option bits set are supported for this extension
BOOL AnimationPlugin::SupportsOptions(int ext, DWORD options)
{
	return false;
}


// class descriptor
/////////////////////////////////////////////////////////////////////////////
class AnimationPluginDesc : public ClassDesc2 
{
public:
	int IsPublic()
	{
		return TRUE;
	}

	void *Create(BOOL loading = FALSE)
	{
		return new AnimationPlugin();
	}

	const TCHAR *ClassName()
	{
		return "AnimationPlugin";
	}

	SClass_ID SuperClassID()
	{
		return SCENE_EXPORT_CLASS_ID;
	}
	
	Class_ID ClassID()
	{
		return ANIMATION_PLUGIN_CLASS_ID;
	}

	const TCHAR* Category()
	{
		return "Category";
	}

	const TCHAR* InternalName()
	{
		return "AnimationPlugin";
	}

	HINSTANCE HInstance()
	{
		return hinstance;
	}

}; // end class ExportPluginDesc

static AnimationPluginDesc animation_plugin_desc;
ClassDesc2* GetAnimationPluginDesc()
{
	return &animation_plugin_desc;
}
