// vertex.cpp

#include "vertex.h"
#include "log.h"

// vertex class implementation
Vertex::Vertex()
{
	position = tc0 = tc1 = tc2 = tc3 = normal = 0;
}

Vertex::Vertex(unsigned long p, unsigned long tc0, unsigned long tc1, 
		unsigned long tc2, unsigned long tc3, unsigned long n)
{
	position = p;
	this->tc0 = tc0;
	this->tc1 = tc1;
	this->tc2 = tc2;
	this->tc3 = tc3;
	normal = n;
}

Vertex::~Vertex()
{

}

static char tb[512];

std::string Vertex::GetString() const
{
	sprintf(tb, "%d%d%d%d%d%d", position, tc0, tc1, tc2, tc3, normal);
	return std::string(tb);
}

static bool operator <(const std::string &s1, const std::string &s2)
{
	return strcmp(s1.c_str(), s2.c_str());
}

bool Vertex::operator < (const Vertex &v) const
{
	return this->GetString() < v.GetString();
}

bool Vertex::operator ==(const Vertex& v)
{
	if (position == v.position &&
		tc0 == v.tc0 &&
		tc1 == v.tc1 &&
		tc2 == v.tc2 &&
		tc3 == v.tc3 &&
		normal == v.normal)
	{
		return true;
	}

	return false;
}

// VertexBuffer class implementation
unsigned long VertexBuffer::Insert(const Vertex& v)
{
	//if (vmap[v]) return vmap[v] - 1;


	/*
	// avoid duplicate insertion
	for (unsigned long i=0; i<verts.size(); i++)
	{
		if (verts[i] == v) return i;
	}
	*/

	static unsigned long lala = 0;
	unsigned long ret = (unsigned long)verts.size();
	verts.push_back(v);
	//vmap[v] = ret + 1;
	return ret;
}


unsigned long VertexBuffer::GetNumVerts() const
{
	return (unsigned long)verts.size();
}
Vertex VertexBuffer::GetArxidia(unsigned long i) const
{
	if (i >= verts.size())
	{
		Log("Requesting invalid vertex: %d, size = %d\n", i, verts.size());
		return Vertex();
	}
	return verts[i];
}

VertexList VertexBuffer::GetVerts() const
{
	return verts;
}
