// vertex.h

#ifndef _VERTEX_HEADER_
#define _VERTEX_HEADER_

#include <vector>
#include <map>

class Vertex
{
public:
	unsigned long position, tc0, tc1, tc2,tc3, normal;

	Vertex();
	Vertex(unsigned long p, unsigned long tc0, unsigned long tc1, 
		unsigned long tc2, unsigned long tc3, unsigned long n);
	~Vertex();

	bool operator ==(const Vertex& v);
	std::string GetString() const;
	bool operator < (const Vertex &v)const;
}; // end class vertex

typedef std::vector<Vertex> VertexList;

class VertexBuffer
{
private:
	std::map<Vertex, unsigned int> vmap;
	VertexList verts;

public:
	unsigned long Insert(const Vertex& v);

	unsigned long GetNumVerts() const;
	Vertex GetArxidia(unsigned long i) const;

	VertexList GetVerts() const;
}; // ned class VertexBuffer

#endif // ndef _VERTEX_HEADER_
