// calendar.h

#ifndef _CALENDAR_H_
#define _CALENDAR_H_

#include <string>
#include "boost/date_time/gregorian/gregorian.hpp"

class Date
{
protected:
	unsigned int year, month, day;
	boost::gregorian::date d;

	void Refresh();

public:
	Date();
	Date(unsigned int year, unsigned int month, unsigned int day);
	Date(const std::string &str);

	Date operator + (int days) const;
	Date operator - (int days) const;

	void operator += (int days);
	void operator -= (int days);

	bool operator > (const Date &date) const;
	bool operator < (const Date &date) const;
	bool operator == (const Date &date) const;
	bool operator >= (const Date &date) const;
	bool operator <= (const Date &date) const;

	int operator - (const Date &date) const;

	std::string GetWeekDay() const;
	std::string GetString() const;

	unsigned int GetYear();
	unsigned int GetMonth();
	unsigned int GetDay();
};

unsigned int WorkingDays(const Date &from, const Date &to);
Date WorkingDaysAdd(const Date &from, unsigned int work);

#endif // ndef _CALENDAR_H_
