// txtfile.h

#ifndef _TXT_FILE_H_
#define _TXT_FILE_H_

#include <map>
#include <string>
#include <vector>

class TxtNode;

typedef std::vector<TxtNode*> TxtNodeList;

class TxtNode
{
protected:
	std::string type;
	std::map<std::string, std::string> values;
	TxtNodeList children;
	TxtNode *parent;

public:
	TxtNode();
	~TxtNode();

	void SetValue(const std::string &which, const std::string &val);
	std::string GetValue(const std::string &which);

	std::string GetType() const;
	void SetType(const std::string &type);

	void Mount(TxtNode *child);
	void Unmount(TxtNode *child);
	TxtNode *GetParent();

	TxtNodeList GetChildren() const;
	TxtNodeList GetChildrenByType(const std::string &type) const;
};

TxtNode* LoadTxt(const char *filename);


#endif // ndef _TXT_FILE_H_
